<template lang="pug">
v-card.mt-4(max-width="300")
  .d-flex.align-end.flex-column
    v-row
      v-col
        v-btn.mx-1(color = "amber darken-1" icon @click="edit()")
          v-icon mdi-square-edit-outline
        v-btn.mx-1(color = "error" icon @click="remove()")
          v-icon mdi-delete
  v-img(:src="WashingMachineImg")
  v-card-title Name: {{ data.name }}
  v-card-subtitle
    |ID: {{ data.id }}
    br
    |Color: {{ data.color }}
  v-card-text
    |Status: {{ data.status.statusName }}
    br
    |Time: {{ timeCount }}
  v-card-action
    v-btn.ma-2(color="green" text @click="start()" v-bind:disabled="startEnable") Start
    v-btn.ma-2(color="red" text @click="end()" v-bind:disabled="endEnable") End
</template>
<script>
import washingMachineImg from '~/assets/img/washing-machie.png'
export default {
  props: {
    data: {
      default: null,
      type: Object
    }
  },
  data () {
    return {
      timeCount: 60,
      endEnable: true,
      startEnable: false,
      WashingMachineImg: washingMachineImg
    }
  },
  methods: {
    remove () {
      this.$emit('remove', this.data)
    },
    edit () {
      this.$emit('edit', this.data)
    },
    start () {
      this.$emit('start', this.data)
      this.startEnable = !this.startEnable
      const countDown = setInterval(() => {
        this.timeCount -= 1
        if (this.timeCount === 0) {
          clearInterval(countDown)
          this.endEnable = !this.endEnable
          this.$emit('finish', { time: this.timeCount, data: this.data })
        }
      }, 1000)
    },
    end () {
      this.$emit('end', this.data)
      this.startEnable = !this.startEnable
      this.endEnable = !this.endEnable
      this.timeCount = 10
    }
  }
}
</script>
